#!/usr/bin/perl
#
# This programs creates a set of fits files
# extracting the information from the line-fitting results.
#



use Astro::FITS::CFITSIO qw( :longnames :constants );
use PDL;

use PDL::Fit::Polynomial; 
use PDL::Filter::Linear;
use PGPLOT;  # Load PGPLOT module
use PDL::Fit::Gaussian;


require "/home/sanchez/sda2/code/R3D/my.pl";

if ($#ARGV<1) {
    print "USE: cube2rss.pl input_cube.fits output_RSS.fits\n";
    exit;
}

$input_cube=$ARGV[0];
$output_rss=$ARGV[1];




$in_pdl=rfits($input_cube);
$h=$in_pdl->gethdr;

($nx,$ny,$nz)=$in_pdl->dims;
$npx=$nx*$ny;
$out_pdl=zeroes($nz,$npx);
for ($k=0;$k<$nz;$k++) {    
    for ($j=0;$j<$ny;$j++) {
	for ($i=0;$i<$nx;$i++) {
	    $px=$j+($nx-1-$i)*$ny;
#	    print "$px/$npx $k/$nz, $i,$j,$k\n";
	    $val=$in_pdl->at($i,$j,$k);
	    set($out_pdl,$k,$px,$val);
	}
    }
}
$out_pdl->sethdr($h);
$out_pdl->wfits($output_rss);

exit;
